// Generated by CoffeeScript 1.6.3
(function() {
  var Base, events, _ref,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  events = require('events');

  /*
  Base class used by Notifier and Monitor.
  It provides a basic framework to manage states.
  Implementers must implement
  @states ( a hashmap of states to handlers )
  @public_api ( with handlers )
  
  It also extends events.EventEmitter ( node.js standard )
  */


  module.exports = Base = (function(_super) {
    __extends(Base, _super);

    function Base() {
      _ref = Base.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    Base.prototype.state = 'ready';

    Base.prototype.transition = function(state, f) {
      var handler;
      if (!(state in this.states)) {
        throw new Error('Invalid Transition ' + ("" + this.state + " -> " + state));
      }
      if (this.state === 'ready') {
        if (typeof f === "function") {
          f();
        }
        this.state = state;
        if (typeof (handler = this.states[state]) === 'string') {
          return typeof this[handler] === "function" ? this[handler]() : void 0;
        }
      }
    };

    return Base;

  })(events.EventEmitter);

}).call(this);
