// Generated by CoffeeScript 1.6.3
(function() {
  var Evaluation, Monitor, Result;

  Monitor = require('./Monitor');

  Result = require('./Result');

  /*
  Internal class that wraps an evaluation
  */


  module.exports = Evaluation = (function() {
    function Evaluation(func) {
      this.func = func;
    }

    Evaluation.prototype.run = function() {
      var e, _ref, _ref1;
      try {
        return new Result({
          result: this.func(),
          monitor: (_ref = this.m) != null ? _ref.public_api : void 0
        });
      } catch (_error) {
        e = _error;
        return new Result({
          error: e,
          monitor: (_ref1 = this.m) != null ? _ref1.public_api : void 0
        });
      } finally {
        delete this.func;
        delete this.m;
      }
    };

    /*
    An Evaluation owns a Monitor.
    But the Monitor is only created if a Notifier is requested
    */


    Evaluation.prototype.monitor = function() {
      return this.m != null ? this.m : this.m = new Monitor;
    };

    /*
    You can request N notifiers
    ( they will be provisioned by the current monitor )
    
    returns 'undefined' if reactivity is not active in this call stack.
    In previous versions we returned a NOOP function.
    
    While returning undefined imposes a burden on the developer
    ( he has to check for this condition ), by making him aware of the fact
    that reactivity may not always be active, we give him an opportunity to perform
    some optimizations.
    After reviewing several apps I have noticed that this is indeed a very common
    situation.
    */


    Evaluation.prototype.notifier = function() {
      return this.monitor().evaluation$create_notifier().public_api;
    };

    return Evaluation;

  })();

}).call(this);
