// Generated by CoffeeScript 1.6.3
(function() {
  var GLOBAL, build, conditional_build, core, util, version, _cell, _poll, _subscribe;

  core = require('./core');

  _poll = require('./poll');

  _subscribe = require('./subscribe');

  version = require('./version');

  util = require('./util');

  _cell = require('./cell');

  /*
  Main entry point to the reactivity framework.
  Exports an object that exposes the 5 API methods.
  The object is itself an overloaded function that proxies
  to the methods for convenience.
  */


  build = function() {
    var active, cell, main, notifier, poll, run, subscribe, _c, _ref;
    _ref = _c = core(), notifier = _ref.notifier, active = _ref.active, run = _ref.run;
    subscribe = _subscribe(_c);
    poll = _poll(_c);
    cell = _cell(_c);
    main = function() {
      var a, inv, is_func, r;
      inv = function() {
        throw new Error('invalid arguments ', arguments);
      };
      is_func = function(v) {
        return typeof v === 'function';
      };
      a = arguments;
      switch (a.length) {
        case 0:
          return cell();
        case 1:
          if (is_func(a[0])) {
            return run(a[0]);
          } else {
            r = cell();
            r(a[0]);
            return r;
          }
          break;
        case 2:
          if (is_func(a[0]) && is_func(a[1])) {
            return subscribe(a[0], a[1]);
          } else {
            return inv();
          }
          break;
        default:
          return inv();
      }
    };
    main.notifier = notifier;
    main.active = active;
    main.run = run;
    main.subscribe = subscribe;
    main.poll = poll;
    main.cell = cell;
    main.version = version;
    return main;
  };

  GLOBAL = global || window;

  (conditional_build = function() {
    var create, other, other_version;
    create = false;
    if ((other = GLOBAL.reactivity) != null) {
      other_version = other.version || '0.0.0';
      if (util.compare_semver(version, other_version) === 'GT') {
        create = true;
      }
    } else {
      create = true;
    }
    if (create) {
      return GLOBAL.reactivity = build();
    }
  })();

  module.exports = GLOBAL.reactivity;

}).call(this);
